import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)


public class BlacMan extends Mover
{
    private GreenfootImage image1;
    private GreenfootImage image2;
    public int dotsEaten;
    private boolean imageChanged;
    
    public BlacMan()
    {
        image1 = new GreenfootImage("pacman_open_right.png");
        image2 = new GreenfootImage("pacman_closed.png");
        setImage(image1);
        dotsEaten = 0;
    }
        
    /** 
     * Act - do whatever the crab wants to do. This method is called whenever
     *  the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        lookForDot();
        moveMe(2);
    }
            
    private void moveMe(int distance)
    {
            //TO DO: clean this up (array/switch?)
            if(Greenfoot.isKeyDown("up"))
            {
                setLocation(getX(), getY()-distance);
                if(!imageChanged)
                {
                    setImage("pacman_open_up.png");
                    imageChanged = true;
                }
                else
                {
                    setImage("pacman_closed.png");
                    imageChanged = false;
                }
            }
            else if(Greenfoot.isKeyDown("down"))
            {
                setLocation(getX(), getY()+distance);
                if(!imageChanged)
                {
                    setImage("pacman_open_down.png");
                    imageChanged = true;
                }
                else
                {
                    setImage("pacman_closed.png");
                    imageChanged = false;
                }
            }
            else if(Greenfoot.isKeyDown("left"))
            {
                setLocation(getX()-distance, getY());
                if(!imageChanged)
                {
                    setImage("pacman_open_left.png");
                    imageChanged = true;
                }
                else
                {
                    setImage("pacman_closed.png");
                    imageChanged = false;
                }
            }
            else if(Greenfoot.isKeyDown("right"))
            {
                setLocation(getX()+distance, getY());
                if(!imageChanged)
                {
                    setImage("pacman_open_right.png");
                    imageChanged = true;
                }
                else
                {
                    setImage("pacman_closed.png");
                    imageChanged = false;
                }
            }
            else
            {
                setLocation(getX(),getY());
            }

    }
    
    /**
     * Check whether we have stumbled upon a worm.
     * If we have, eat it. If not, do nothing. If we have
     * eaten eight worms, we win.
     */
    public void lookForDot()
    {
        if ( canSee(Dot.class) ) 
        {
            eat(Dot.class);
            dotsEaten = dotsEaten + 1;
            if(dotsEaten == 30) //specified in World Class BlacWorld
            {
                setImage("pacman_smile.png");
                Greenfoot.playSound("fanfare.wav");
                Greenfoot.stop();
            }
        }
    }
    
}