import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

public class Ghost extends Mover
{
    public Ghost()
    {
        randomImage();
    }
    /**
     * Do whatever lobsters do.
     */
    public void act()
    {
        turnAtEdge();
        randomTurn();
        move();
        lookForBlacMan();
    }
    
    private void randomImage()
    {
        String images[] = {"ghost", "ghost_y", "ghost_p"};
        int randomImageChoice = Greenfoot.getRandomNumber(images.length);
        setImage(images[randomImageChoice]+".png");
    }

    /**
     * Check whether we are at the edge of the world. If we are, turn a bit.
     * If not, do nothing.
     */
    public void turnAtEdge()
    {
        if ( atWorldEdge() ) 
        {
            turn(20);
        }
    }

    /**
     * Randomly decide to turn from the current direction, or not. If we turn
     * turn a bit left or right by a random degree.
     */
    public void randomTurn()
    {
        if (Greenfoot.getRandomNumber(100) > 90) {
            turn(Greenfoot.getRandomNumber(90)-45);
        }
    }

    /**
     * Try to pinch a crab. That is: check whether we have stumbled upon a crab.
     * If we have, remove the crab from the game, and stop the program running.
     */
    public void lookForBlacMan()
    {
        if ( canSee(BlacMan.class) ) 
        {
            eat(BlacMan.class);
            Greenfoot.playSound("au.wav");
            Greenfoot.stop();
        }
    }
}